searchNodes=[{"doc":"","ref":"Defr.html","title":"Defr","type":"module"},{"doc":"defr transforms a function to accept a map where dependent functions and modules can be injected.use Defr defr send_welcome_email(user_id) do %{email: email} = Repo.get(User, user_id) welcome_email(to: email) |&gt; Mailer.send() endis expanded into (simplified to understand)def send_welcome_email(user_id, deps \\\\ %{}) do %{email: email} = Map.get(deps, &amp;Repo.get/2, :erlang.make_fun(Map.get(deps, Repo, Repo), :get, 2) ).(User, user_id) welcome_email(to: email) |&gt; Map.get(deps, &amp;Mailer.send/1, :erlang.make_fun(Map.get(deps, Mailer, Mailer), :send, 1) ).() endNote that local function calls like welcome_email(to: email) are not expanded unless it is prepended with __MODULE__.Now, you can inject mock functions and modules in tests.test &quot;send_welcome_email&quot; do Accounts.send_welcome_email(100, %{ Repo =&gt; MockRepo, &amp;Mailer.send/1 =&gt; fn %Email{to: &quot;user100@gmail.com&quot;, subject: &quot;Welcome&quot;} -&gt; Process.send(self(), :email_sent) end }) assert_receive :email_sent enddefr raises if the passed map includes a function or a module that's not used within the injected function. You can disable this by adding strict: false option.test &quot;send_welcome_email with strict: false&quot; do Accounts.send_welcome_email(100, %{ &amp;Repo.get/2 =&gt; fn User, 100 -&gt; %User{email: &quot;user100@gmail.com&quot;} end, &amp;Repo.all/1 =&gt; fn _ -&gt; [%User{email: &quot;user100@gmail.com&quot;}] end, # Unused strict: false }) end","ref":"Defr.html#defr/2","title":"Defr.defr/2","type":"macro"},{"doc":"If you don't need pattern matching in mock function, mock/1 can be used to reduce boilerplates.use Defr test &quot;send_welcome_email with mock/1&quot; do Accounts.send_welcome_email(100) |&gt; Reader.run( mock(%{ &amp;Mailer.send/1 =&gt; Process.send(self(), :email_sent) }) ) assert_receive :email_sent endNote that Process.send(self(), :email_sent) is surrounded by fn _ -&gt; end when expanded.","ref":"Defr.html#mock/1","title":"Defr.mock/1","type":"macro"},{"doc":"","ref":"Defr.Runner.html","title":"Defr.Runner","type":"module"},{"doc":"","ref":"Defr.Runner.html#run/3","title":"Defr.Runner.run/3","type":"function"},{"doc":"","ref":"Sample.html","title":"Sample","type":"module"},{"doc":"","ref":"Sample.html#div/2","title":"Sample.div/2","type":"function"},{"doc":"","ref":"Sample.html#hello/1","title":"Sample.hello/1","type":"function"},{"doc":"","ref":"Sample.Calc.html","title":"Sample.Calc","type":"module"},{"doc":"","ref":"Sample.Calc.html#div/2","title":"Sample.Calc.div/2","type":"function"},{"doc":"","ref":"Sample.Calc.html#id/1","title":"Sample.Calc.id/1","type":"function"},{"doc":"","ref":"Sample.Calc.html#macro_sum/2","title":"Sample.Calc.macro_sum/2","type":"macro"},{"doc":"","ref":"Sample.Calc.html#sum/2","title":"Sample.Calc.sum/2","type":"function"},{"doc":"","ref":"Sample.Calc.html#to_int/1","title":"Sample.Calc.to_int/1","type":"function"},{"doc":"defr is def for Witchcraft's Reader monads.","ref":"readme.html","title":"README","type":"extras"},{"doc":"The package can be installed by adding defr to your list of dependencies in mix.exs:def deps do [{:defr, &quot;~&gt; 0.1&quot;}] endTo format defr like def, add following to your .formatter.exslocals_without_parens: [defr: 2]","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"defmodule Defr.NestedCallTest do use ExUnit.Case, async: true use Defr alias Algae.Reader alias Algae.Either.Right defmodule User do use Defr defstruct [:id, :name] defr get_by_id(user_id) do Repo.get(__MODULE__, user_id) |&gt; Right.new() end end defmodule Accounts do use Defr defr get_user_by_id(user_id) do monad %Right{} do user &lt;- User.get_by_id(user_id) user |&gt; Right.new() end end end defmodule UserController do use Defr defr profile(user_id_str) do user_id = String.to_integer(user_id_str) Accounts.get_user_by_id(user_id) end end test &quot;inject 3rd layer&quot; do assert [{:profile, 1}] == UserController.__reader_funs__() assert %Right{right: %User{id: 1, name: &quot;josevalim&quot;}} == UserController.profile(&quot;1&quot;) |&gt; Reader.run(%{&amp;Repo.get/2 =&gt; fn _, _ -&gt; %User{id: 1, name: &quot;josevalim&quot;} end}) end test &quot;inject 2nd layer&quot; do assert [{:get_user_by_id, 1}] == Accounts.__reader_funs__() assert %Right{right: %User{id: 2, name: &quot;chrismccord&quot;}} == UserController.profile(&quot;2&quot;) |&gt; Reader.run(%{ &amp;User.get_by_id/1 =&gt; fn _ -&gt; Reader.new(fn _ -&gt; Right.new(%User{id: 2, name: &quot;chrismccord&quot;}) end) end }) end endmockIf you don't need pattern matching in mock function, mock/1 can be used to reduce boilerplates.UserController.profile(&quot;1&quot;) |&gt; Reader.run(%{&amp;Repo.get/2 =&gt; fn _, _ -&gt; %User{} end})can be changed toUserController.profile(&quot;1&quot;) |&gt; Reader.run(%{&amp;Repo.get/2 =&gt; mock(%User{})})","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"This project is licensed under the MIT License - see the LICENSE file for details","ref":"readme.html#license","title":"README - License","type":"extras"}]